extern int combos[3][26][26][7][2][4];
int w,x,y,z,s,u;

void fillcombinations(void)
 {
  /*
  combos array
  w = active, x = letter short code value, y = letter serial number value, z = value of the note, s = series, u = signature
  short code: A=0,B=1,C=2,D=3,E=4,F=5,G=6,H=7,I=8,J=9,K=10,L=11,M=12,N=13,O=14,P=15,Q=16,
              R=17,S=18,T=19,U=20,V=21,W=22,X=23,Y=24,Z=25
  serial number: A=0,B=1,C=2,D=3,E=4,F=5,G=6,H=7,I=8,J=9,K=10,L=11,M=12,N=13,O=14,P=15,Q=16,
                 R=17,S=18,T=19,U=20,V=21,W=22,X=23,Y=24,Z=25
  note value: 5=0,10=1,20=2,50=3,100=4,200=5,500=6
  series: 0 = 2002 series, 1 = Europa series
  signature: 0 = WD, 1 = JCT, 2 = MD
  w  x  y z s u
  1  3 11 0 0 0 D/L 5
  1  3 11 1 0 0 D/L 10
  1  3 11 2 0 0 D/L 20
  1  3 11 3 0 0 D/L 50
  1  3 11 4 0 0 D/L 100
  1  3 11 5 0 0 D/L 200
  1  3 11 6 0 0 D/L 500
  1  4  4 0 0 1 E/E 5
  1  4  4 1 1 2 E/E 10 Europa
  1  4  4 2 1 2 E/E 20 Europa
  1  4  4 3 1 2 E/E 50 Europa
  1  4  5 0 0 1 E/F 5
  1  4  6 0 0 1 E/G 5
  1  4  7 0 0 1 E/H 5
  1  4  7 2 0 1 E/H 20
  1  4 11 0 0 1 E/L 5
  1  4 11 2 0 1 E/L 20
  1  4 15 0 0 1 E/P 5
  ...
  1 20 12 2 0 2 U/M 20
  1 20 20 0 1 2 U/U 5 Europa
  1 20 20 1 1 2 U/U 10 Europa
  1 20 20 2 1 2 U/U 20 Europa
  1 20 20 3 1 2 U/U 50 Europa
  1 21 21 0 1 2 V/V 5 Europa
  1 21 21 1 1 2 V/V 10 Europa
  1 21 21 2 1 2 V/V 20 Europa
  1 21 21 3 1 2 V/V 50 Europa
  1 23 23 1 1 2 X/X 10 Europa
  1 23 23 2 1 2 X/X 20 Europa
  1 24 24 0 1 2 Y/Y 5 Europa
  1 24 24 1 1 2 Y/Y 10 Europa
  1 25 25 0 1 2 Z/Z 5 Europa
  1 25 25 2 1 2 Z/Z 20 Europa
  1 25 25 3 1 2 Z/Z 50 Europa
  */

  // initialize an array with all entries set to zero 
  for(w=0; w<3; w++)
   {
    for(x=0;x<26;x++)
     {
      for(y=0;y < 26;y++)
       {
        for(z=0;z < 7;z++)
         {
          for(s=0;s < 2;s++)
           {
            for(u=0;u < 4; u++)
             {
              combos[w][x][y][z][s][u]=0;
             }
           }
         }
       }
     }
   }

  // active notes
  combos[1][3][11][0][0][0]=1; // D/L 5 2002 WD
  combos[1][3][11][1][0][0]=1; // D/L 10 2002 WD
  combos[1][3][11][2][0][0]=1; // D/L 20 2002 WD
  combos[1][3][11][3][0][0]=1; // D/L 50 2002 WD
  combos[1][3][11][4][0][0]=1; // D/L 100 2002 WD
  combos[1][3][11][5][0][0]=1; // D/L 200 2002 WD
  combos[1][3][11][6][0][0]=1; // D/L 500 2002 WD
  combos[1][4][4][0][0][1]=1; // E/E 5 2002 JCT
  combos[1][4][4][0][1][3]=1; // E/E 5 Europa CL
  combos[1][4][4][1][1][2]=1; // E/E 10 Europa MD
  combos[1][4][4][2][1][2]=1; // E/E 20 Europa MD
  combos[1][4][4][2][1][3]=1; // E/E 20 Europa CL
  combos[1][4][4][3][1][2]=1; // E/E 50 Europa MD
  combos[1][4][4][3][1][3]=1; // E/E 50 Europa CL
  combos[1][4][4][4][1][2]=1; // E/E 100 Europa MD
  combos[1][4][4][4][1][3]=1; // E/E 100 Europa CL
  combos[1][4][4][5][1][3]=1; // E/E 200 Europa CL
  combos[1][4][5][0][0][1]=1; // E/F 5 2002 JCT
  combos[1][4][6][0][0][1]=1; // E/G 5 2002 JCT
  combos[1][4][7][0][0][1]=1; // E/H 5 2002 JCT
  combos[1][4][7][2][0][1]=1; // E/H 20 2002 JCT
  combos[1][4][11][0][0][1]=1; // E/L 5 2002 JCT
  combos[1][4][11][2][0][1]=1; // E/L 20 2002 JCT
  combos[1][4][15][0][0][1]=1; // E/P 5 2002 JCT
  combos[1][4][20][2][0][0]=1; // E/U 20 2002 WD
  combos[1][4][20][4][0][0]=1; // E/U 100 2002 WD
  combos[1][4][23][1][0][1]=1; // E/X 10 2002 JCT
  combos[1][4][23][1][0][2]=1; // E/X 10 2002 MD
  combos[1][4][23][2][0][2]=1; // E/X 20 2002 MD
  combos[1][4][23][3][0][2]=1; // E/X 50 2002 MD
  combos[1][4][23][4][0][2]=1; // E/X 100 2002 MD
  combos[1][4][23][5][0][1]=1; // E/X 200 2002 JCT
  combos[1][4][23][5][0][2]=1; // E/X 200 2002 MD
  combos[1][5][5][1][1][2]=1; // F/F 10 Europa MD
  combos[1][5][5][2][1][3]=1; // F/F 20 Europa CL
  combos[1][5][13][0][0][0]=1; // F/N 5 2002 WD
  combos[1][5][13][0][0][1]=1; // F/N 5 2002 JCT
  combos[1][5][13][1][0][0]=1; // F/N 10 2002 WD
  combos[1][5][13][1][0][1]=1; // F/N 10 2002 JCT
  combos[1][5][13][2][0][0]=1; // F/N 20 2002 WD
  combos[1][5][13][2][0][1]=1; // F/N 20 2002 JCT
  combos[1][5][13][3][0][0]=1; // F/N 50 2002 WD
  combos[1][5][13][4][0][0]=1; // F/N 100 2002 WD
  combos[1][5][13][4][0][1]=1; // F/N 100 2002 JCT
  combos[1][5][13][4][0][2]=1; // F/N 100 2002 MD
  combos[1][5][13][6][0][0]=1; // F/N 500 2002 WD
  combos[1][5][13][6][0][1]=1; // F/N 500 2002 JCT
  combos[1][5][13][6][0][2]=1; // F/N 500 2002 MD
  combos[1][5][15][0][0][0]=1; // F/P 5 2002 WD
  combos[1][5][15][6][0][0]=1; // F/P 500 2002 WD
  combos[1][5][18][3][0][1]=1; // F/S 50 2002 JCT
  combos[1][5][19][6][0][0]=1; // F/T 500 2002 WD
  combos[1][5][24][1][0][0]=1; // F/Y 10 2002 WD
  combos[1][6][4][2][0][1]=1; // G/E 20 2002 JCT
  combos[1][6][5][2][0][1]=1; // G/F 20 2002 JCT
  combos[1][6][6][2][0][1]=1; // G/G 20 2002 JCT
  combos[1][6][7][2][0][1]=1; // G/H 20 2002 JCT
  combos[1][6][11][2][0][1]=1; // G/L 20 2002 JCT
  combos[1][6][13][5][0][0]=1; // G/N 200 2002 WD
  combos[1][6][15][0][0][0]=1; // G/P 5 2002 WD
  combos[1][6][15][1][0][0]=1; // G/P 10 2002 WD
  combos[1][6][15][1][0][1]=1; // G/P 10 2002 JCT
  combos[1][6][15][2][0][0]=1; // G/P 20 2002 WD
  combos[1][6][15][2][0][1]=1; // G/P 20 2002 JCT
  combos[1][6][15][3][0][0]=1; // G/P 50 2002 WD
  combos[1][6][15][3][0][1]=1; // G/P 50 2002 JCT
  combos[1][6][15][4][0][0]=1; // G/P 100 2002 WD
  combos[1][6][15][4][0][1]=1; // G/P 100 2002 JCT
  combos[1][6][15][5][0][0]=1; // G/P 200 2002 WD
  combos[1][6][21][1][0][0]=1; // G/V 10 2002 WD
  combos[1][6][23][1][0][1]=1; // G/X 10 2002 JCT
  combos[1][6][23][3][0][1]=1; // G/X 50 2002 JCT
  combos[1][6][23][3][0][2]=1; // G/X 50 2002 MD
  combos[1][6][24][3][0][0]=1; // G/Y 50 2002 WD
  combos[1][6][24][4][0][0]=1; // G/Y 100 2002 WD
  combos[1][7][11][2][0][1]=1; // H/L 20 2002 JCT
  combos[1][7][11][3][0][0]=1; // H/L 50 2002 WD
  combos[1][7][11][4][0][1]=1; // H/L 100 2002 WD
  combos[1][7][12][2][0][0]=1; // H/M 20 2002 WD
  combos[1][7][12][3][0][0]=1; // H/M 50 2002 WD
  combos[1][7][15][3][0][0]=1; // H/P 50 2002 WD
  combos[1][7][19][2][0][0]=1; // H/T 20 2002 WD
  combos[1][9][18][0][0][0]=1; // J/S 5 2002 WD
  combos[1][9][18][1][0][0]=1; // J/S 10 2002 WD
  combos[1][9][18][1][0][1]=1; // J/S 10 2002 JCT
  combos[1][9][18][2][0][0]=1; // J/S 20 2002 WD
  combos[1][9][18][2][0][1]=1; // J/S 20 2002 JCT
  combos[1][9][18][2][0][2]=1; // J/S 20 2002 MD
  combos[1][9][18][3][0][0]=1; // J/S 50 2002 WD
  combos[1][9][18][3][0][1]=1; // J/S 50 2002 JCT
  combos[1][9][18][3][0][2]=1; // J/S 50 2002 MD
  combos[1][9][18][4][0][0]=1; // J/S 100 2002 WD
  combos[1][9][18][4][0][1]=1; // J/S 100 2002 JCT
  combos[1][9][18][5][0][0]=1; // J/S 200 2002 WD
  combos[1][9][18][6][0][0]=1; // J/S 500 2002 WD
  combos[1][10][19][0][0][0]=1; // K/T 5 2002 WD
  combos[1][10][19][0][0][1]=1; // K/T 5 2002 JCT
  combos[1][10][19][1][0][0]=1; // K/T 10 2002 WD
  combos[1][10][19][1][0][1]=1; // K/T 10 2002 JCT
  combos[1][10][19][1][0][2]=1; // K/T 10 2002 MD
  combos[1][10][19][2][0][0]=1; // K/T 20 2002 WD
  combos[1][10][19][2][0][1]=1; // K/T 20 2002 JCT
  combos[1][10][19][3][0][0]=1; // K/T 50 2002 WD
  combos[1][10][19][4][0][0]=1; // K/T 100 2002 WD
  combos[1][11][20][0][0][0]=1; // L/U 5 2002 WD
  combos[1][11][20][0][0][1]=1; // L/U 5 2002 JCT
  combos[1][11][20][1][0][0]=1; // L/U 10 2002 WD
  combos[1][11][20][1][0][1]=1; // L/U 10 2002 JCT
  combos[1][11][20][2][0][0]=1; // L/U 20 2002 WD
  combos[1][11][20][2][0][1]=1; // L/U 20 2002 JCT
  combos[1][11][20][2][0][2]=1; // L/U 20 2002 MD
  combos[1][11][20][3][0][0]=1; // L/U 50 2002 WD
  combos[1][12][12][0][1][2]=1; // M/M 5 Europa MD
  combos[1][12][12][0][1][3]=1; // M/M 5 Europa CL
  combos[1][12][12][1][1][3]=1; // M/M 10 Europa CL
  combos[1][12][12][2][1][2]=1; // M/M 20 Europa MD
  combos[1][12][12][2][1][3]=1; // M/M 20 Europa CL
  combos[1][12][12][3][1][2]=1; // M/M 50 Europa MD
  combos[1][12][21][0][0][0]=1; // M/V 5 2002 WD
  combos[1][12][21][0][0][1]=1; // M/V 5 2002 JCT
  combos[1][12][21][1][0][0]=1; // M/V 10 2002 WD
  combos[1][12][21][2][0][0]=1; // M/V 20 2002 WD
  combos[1][12][21][2][0][1]=1; // M/V 20 2002 JCT
  combos[1][12][21][3][0][0]=1; // M/V 50 2002 WD
  combos[1][12][21][3][0][1]=1; // M/V 50 2002 JCT
  combos[1][12][21][3][0][2]=1; // M/V 50 2002 MD
  combos[1][12][21][4][0][0]=1; // M/V 100 2002 WD
  combos[1][12][21][4][0][2]=1; // M/V 100 2002 MD
  combos[1][13][13][0][1][2]=1; // N/N 5 Europa MD
  combos[1][13][13][0][1][3]=1; // N/N 5 Europa CL
  combos[1][13][13][1][1][2]=1; // N/N 10 Europa MD
  combos[1][13][13][1][1][3]=1; // N/N 10 Europa CL
  combos[1][13][13][2][1][2]=1; // N/N 20 Europa MD
  combos[1][13][13][2][1][3]=1; // N/N 20 Europa CL
  combos[1][13][13][3][1][2]=1; // N/N 50 Europa MD
  combos[1][13][13][4][1][2]=1; // N/N 100 Europa MD
  combos[1][13][13][5][1][2]=1; // N/N 200 Europa MD
  combos[1][13][13][5][1][3]=1; // N/N 200 Europa CL
  combos[1][13][24][0][0][0]=1; // N/Y 5 2002 WD
  combos[1][13][24][1][0][0]=1; // N/Y 10 2002 WD
  combos[1][13][24][1][0][1]=1; // N/Y 10 2002 JCT
  combos[1][13][24][1][0][2]=1; // N/Y 10 2002 MD
  combos[1][13][24][2][0][0]=1; // N/Y 20 2002 WD
  combos[1][13][24][2][0][1]=1; // N/Y 20 2002 JCT
  combos[1][13][24][2][0][2]=1; // N/Y 20 2002 MD
  combos[1][13][24][3][0][0]=1; // N/Y 50 2002 WD
  combos[1][15][11][2][0][1]=1; // P/L 20 2002 JCT
  combos[1][15][12][4][0][0]=1; // P/M 100 2002 WD
  combos[1][15][15][0][0][0]=1; // P/P 5 2002 WD
  combos[1][15][15][1][0][0]=1; // P/P 10 2002 WD
  combos[1][15][15][1][0][1]=1; // P/P 10 2002 JCT
  combos[1][15][15][1][1][2]=1; // P/P 10 Europa MD
  combos[1][15][15][2][0][0]=1; // P/P 20 2002 WD
  combos[1][15][15][3][1][2]=1; // P/P 50 Europa MD
  combos[1][15][20][4][0][0]=1; // P/U 100 2002 WD
  combos[1][15][21][3][0][0]=1; // P/V 50 2002 WD
  combos[1][15][23][0][0][0]=1; // P/X 5 2002 WD
  combos[1][15][23][0][0][1]=1; // P/X 5 2002 JCT
  combos[1][15][23][1][0][0]=1; // P/X 10 2002 WD
  combos[1][15][23][1][0][1]=1; // P/X 10 2002 JCT
  combos[1][15][23][1][0][2]=1; // P/X 10 2002 MD
  combos[1][15][23][2][0][0]=1; // P/X 20 2002 WD
  combos[1][15][23][2][0][1]=1; // P/X 20 2002 JCT
  combos[1][15][23][3][0][0]=1; // P/X 50 2002 WD
  combos[1][15][23][3][0][1]=1; // P/X 50 2002 JCT
  combos[1][15][23][4][0][0]=1; // P/X 100 2002 WD
  combos[1][15][23][4][0][1]=1; // P/X 100 2002 JCT
  combos[1][15][24][0][0][0]=1; // P/Y 5 2002 WD
  combos[1][15][24][4][0][0]=1; // P/Y 100 WD
  combos[1][17][3][2][0][2]=1; // R/D 20 2002 MD
  combos[1][17][3][3][0][2]=1; // R/D 50 2002 MD
  combos[1][17][4][2][0][2]=1; // R/E 20 2002 MD
  combos[1][17][4][3][0][2]=1; // R/E 50 2002 MD
  combos[1][17][5][2][0][2]=1; // R/F 20 2002 MD
  combos[1][17][5][3][0][2]=1; // R/F 50 2002 MD
  combos[1][17][6][2][0][2]=1; // R/G 20 2002 MD
  combos[1][17][6][3][0][2]=1; // R/G 50 2002 MD
  combos[1][17][7][2][0][2]=1; // R/H 20 2002 MD
  combos[1][17][7][3][0][2]=1; // R/H 50 2002 MD
  combos[1][17][11][2][0][2]=1; // R/L 20 2002 MD
  combos[1][17][11][3][0][2]=1; // R/L 50 2002 MD
  combos[1][17][15][0][0][1]=1; // R/P 5 2002 JCT
  combos[1][17][15][2][0][2]=1; // R/P 20 2002 MD
  combos[1][17][15][3][0][2]=1; // R/P 50 2002 MD
  combos[1][17][17][1][1][3]=1; // R/R 10 Europa CL
  combos[1][17][17][2][1][2]=1; // R/R 20 Europa MD
  combos[1][17][17][2][1][3]=1; // R/R 20 Europa CL
  combos[1][17][17][3][1][2]=1; // R/R 50 Europa MD
  combos[1][17][17][3][1][3]=1; // R/R 50 Europa CL
  combos[1][17][17][4][1][2]=1; // R/R 100 Europa MD
  combos[1][17][23][0][0][1]=1; // R/X 5 2002 JCT
  combos[1][17][23][1][0][0]=1; // R/X 10 2002 WD
  combos[1][17][23][1][0][1]=1; // R/X 10 2002 JCT
  combos[1][17][23][2][0][1]=1; // R/X 20 2002 JCT
  combos[1][17][23][3][0][0]=1; // R/X 50 2002 WD
  combos[1][17][23][3][0][1]=1; // R/X 50 2002 JCT
  combos[1][17][23][3][0][2]=1; // R/X 50 2002 MD
  combos[1][17][23][4][0][2]=1; // R/X 100 2002 MD
  combos[1][17][23][5][0][0]=1; // R/X 200 2002 WD
  combos[1][17][23][5][0][2]=1; // R/X 200 2002 MD
  combos[1][17][23][6][0][0]=1; // R/X 500 WD
  combos[1][17][23][6][0][1]=1; // R/X 500 JCT
  combos[1][17][24][5][0][0]=1; // R/Y 200 WD
  combos[1][17][24][6][0][0]=1; // R/Y 500 WD
  combos[1][18][18][0][1][2]=1; // S/S 5 Europa MD
  combos[1][18][18][1][1][2]=1; // S/S 10 Europa MD
  combos[1][18][18][2][1][2]=1; // S/S 20 Europa MD
  combos[1][18][18][2][1][3]=1; // S/S 20 Europa CL
  combos[1][18][18][3][1][2]=1; // S/S 50 Europa MD
  combos[1][18][18][3][1][3]=1; // S/S 50 Europa CL
  combos[1][18][18][4][1][2]=1; // S/S 100 Europa MD
  combos[1][18][18][5][1][2]=1; // S/S 200 Europa MD
  combos[1][19][19][0][1][2]=1; // T/T 5 Europa MD
  combos[1][19][19][1][1][2]=1; // T/T 10 Europa MD
  combos[1][19][19][2][1][2]=1; // T/T 20 Europa MD
  combos[1][19][20][5][0][0]=1; // T/U 200 2002 WD
  combos[1][19][20][6][0][0]=1; // T/U 500 2002 WD
  combos[1][19][21][5][0][0]=1; // T/V 200 2002 WD
  combos[1][19][21][6][0][0]=1; // T/V 500 2002 WD
  combos[1][19][25][0][0][0]=1; // T/Z 5 2002 WD
  combos[1][19][25][1][0][0]=1; // T/Z 10 2002 WD
  combos[1][19][25][2][0][0]=1; // T/Z 20 2002 WD
  combos[1][19][25][3][0][0]=1; // T/Z 50 2002 WD
  combos[1][19][25][3][0][1]=1; // T/Z 50 2002 JCT
  combos[1][19][25][3][0][2]=1; // T/Z 50 2002 MD
  combos[1][19][25][4][0][0]=1; // T/Z 100 2002 WD
  combos[1][19][25][5][0][0]=1; // T/Z 200 2002 WD
  combos[1][19][25][5][0][2]=1; // T/Z 200 2002 MD
  combos[1][19][25][6][0][0]=1; // T/Z 500 2002 WD
  combos[1][20][12][0][0][0]=1; // U/M 5 2002 WD
  combos[1][20][12][0][0][1]=1; // U/M 5 2002 JCT
  combos[1][20][12][1][0][0]=1; // U/M 10 2002 WD
  combos[1][20][12][1][0][1]=1; // U/M 10 2002 JCT
  combos[1][20][12][2][0][0]=1; // U/M 20 2002 WD
  combos[1][20][12][2][0][1]=1; // U/M 20 2002 JCT
  combos[1][20][12][2][0][2]=1; // U/M 20 2002 MD
  combos[1][20][20][0][1][2]=1; // U/U 5 Europa MD
  combos[1][20][20][0][1][3]=1; // U/U 5 Europa CL
  combos[1][20][20][1][1][2]=1; // U/U 10 Europa MD 
  combos[1][20][20][2][1][2]=1; // U/U 20 Europa MD
  combos[1][20][20][2][1][3]=1; // U/U 20 Europa CL
  combos[1][20][20][3][1][2]=1; // U/U 50 Europa MD
  combos[1][20][20][3][1][3]=1; // U/U 50 Europa CL
  combos[1][20][20][4][1][2]=1; // U/U 100 Europa MD
  combos[1][20][20][5][1][2]=1; // U/U 200 Europa MD
  combos[1][21][21][0][1][2]=1; // V/V 5 Europa MD
  combos[1][21][21][0][1][3]=1; // V/V 5 Europa CL
  combos[1][21][21][1][1][2]=1; // V/V 10 Europa MD
  combos[1][21][21][1][1][3]=1; // V/V 10 Europa CL
  combos[1][21][21][2][1][2]=1; // V/V 20 Europa MD
  combos[1][21][21][3][1][2]=1; // V/V 50 Europa MD
  combos[1][21][21][3][1][3]=1; // V/V 50 Europa CL
  combos[1][21][21][4][1][2]=1; // V/V 100 Europa MD
  combos[1][22][22][0][1][2]=1; // W/W 5 Europa MD
  combos[1][22][22][1][1][2]=1; // W/W 10 Europa MD
  combos[1][22][22][1][1][3]=1; // W/W 10 Europa CL
  combos[1][22][22][2][1][2]=1; // W/W 20 Europa MD
  combos[1][22][22][3][1][2]=1; // W/W 50 Europa MD
  combos[1][22][22][3][1][3]=1; // W/W 50 Europa CL
  combos[1][22][22][4][1][3]=1; // W/W 100 Europa CL
  combos[1][23][23][1][1][2]=1; // X/X 10 Europa MD
  combos[1][23][23][2][1][2]=1; // X/X 20 Europa MD
  combos[1][24][24][0][1][2]=1; // Y/Y 5 Europa MD
  combos[1][24][24][1][1][2]=1; // Y/Y 10 Europa MD
  combos[1][24][24][1][1][3]=1; // Y/Y 10 Europa CL
  combos[1][24][24][3][1][2]=1; // Y/Y 50 Europa MD
  combos[1][24][24][3][1][3]=1; // Y/Y 50 Europa CL
  combos[1][25][25][0][1][1]=1; // Z/Z 5 Europa JCT
  combos[1][25][25][0][1][2]=1; // Z/Z 5 Europa MD
  combos[1][25][25][2][1][2]=1; // Z/Z 20 Europa MD
  combos[1][25][25][3][1][2]=1; // Z/Z 50 Europa MD
 }
