#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include "version.h"
#include "notescheck.h"

#define PROGRAMTYPE 2

/* b:          counter for finding the semicolon before the EBT notes id
   c:          counter for all notes
   ebtidstart: first position of the EBT notes id
   en:         for the new Europa series of banknotes, checks if second position in the serial
               number is a digit or not (Europa series should have no digit at this position)
   f:          combination check, at the end: f=1 means valid combination
   fn:         maximum fifth note character in ASCII code, normally it is J, so this value is 74
   i:          for loops, etc
   ms:         maximum sixth note character in ASCII code, normally it is 6, so this value is 54
   n:          value of the note
   t:          first position of the short code
   sc:         correct short value: f=1 means NOT correct short code value
   sn:         beginning position in the string of the serial number
   fcount:     counter unknown combinations
   scount:     semicolons per line (if there are no extra semicolons in the comment, it should be 13)
   tcount:     counter for typing error in the short code value
   y:          for posistion of the year in the CSV value
   year:       the int value of the year of the note, after the first semicolon in the CSV file */

int b=0, c=0, ebtidstart=0, f=0, fn=74, i=0, ms=54, n=0, t=0; /* , y=0; we might need this later*/
int sc=0, sn=0, en=0;
int fcount=0, scount=0, tcount=0; /* , year=0; we might need this later */

/* a buffer, read it line after line from CSV file */
char puffer[1024];

int main( int argc, char *argv[] )
 {
  /* this points to the CSV file */
  FILE *quelle;

  /* these four long ints are used for time calculation - how long does it take to check the notes */
  long int time1, time2, thou, sec;

  /* start time */
  time1 = clock();

  printf("<HTML><HEAD><TITLE>HTML EBT Notes Check</TITLE></HEAD>\n<BODY>HTML EBT Notes Check version ");
  printf("%s by marty44 from %s", PROGRAMVERSION, PROGRAMDATE);
  printf("<BR>\nprinter short codes are taken from <A HREF=\"http://liste.eurobillets.free.fr/\" target=_blank>http://liste.eurobillets.free.fr/</A> (updated %s", LISTDATE);
  printf(")<BR>\nyou can reach me via the EBT forum (username marty44)<BR>\n");
  printf("thread about EBT Notes Check: <A HREF=\"https://forum.eurobilltracker.com/viewtopic.php?f=5&t=21676\" target=_blank>https://forum.eurobilltracker.com/viewtopic.php?f=5&t=21676</A><P>\n");
  printf("Please try my online tool too: EBTCheck, see <A HREF=\"https://ebtcheck.marty44.net/ebtcheck/\" target=_blank>https://ebtcheck.marty44.net/ebtcheck/</A>\n");
  printf("It checks your CSV file too and is able to generate some statistics.<BR>\n");
  printf("Example: <A HREF=\"https://ebtcheck.marty44.net/ebtcheck/user23/\" target=_blank>https://ebtcheck.marty44.net/ebtcheck/user23/</A><P>\n");
  printf("before you can use the edit links, please <FONT COLOR=red>login</FONT> into <A HREF=\"https://www.eurobilltracker.eu/\" target=_blank>EBT</A><HR>\n");

  /* the command line must have 2 arguments (filename of the program and the CSV file) */
  if (argc != 2)
   {
    printf("usage: %s filename<p></BODY></HTML>", argv[0]);
    exit(EXIT_FAILURE);
   }

  /* check if we can open the CSV file */
  if((quelle = fopen(argv[1], "r")) == NULL)
   {
    printf("Could not open %s<p></BODY></HTML>", argv[1]);
    return EXIT_FAILURE;
   }

  /* get the first line and check if it is a valid CSV file */
  fgets(puffer, 1024, quelle);
  for(i=0; i<20; i++)
   {
    if(puffer[i] == 'E') { t=i; break; }
   }
  if(!((puffer[t+1] == 'B') && (puffer[t+10] == 'v') && (puffer[t+11] == '2')))
   {
    printf("%s doesn't look like a EBT notes CSV file. Abort.<p></BODY></HTML>", argv[1]);
    fclose(quelle);
    return EXIT_FAILURE;
   }

  // read in line via line
  while(fgets(puffer, 1024, quelle))
   {
    // call the notescheck subroutine
    notescheck(PROGRAMTYPE);

    // if it is a new Europa series note and the is at the second position in the serial number a digit, it is not correct
    if(en==1)
     {
      printf("It looks like this note is an Europa series note, but there is a digit at the second position in the serial number.\n");
      f=0;
     }

    // if it is no valid combination, print it
    if(f==0)
     {
      fcount++;
      printf("unknown combination: %d Euro note ", n);
      printf("<b>%c%c%c%c%c%c</b> - ", puffer[t], puffer[t+1], puffer[t+2], puffer[t+3], puffer[t+4], puffer[t+5]);
      printf("<b>%c%c%c%c%c%c%c%c%c%c%c%c</b>, ", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11]);
      printf("EBT notes id: ");
      ebtidstart=0;
      b=0;
      // find the position of the semicolon before the ebt notes id
      for(i=0; i<1024; i++)
       {
        if(puffer[i] == ';') b++;
        if(b == ( scount-4 )) { ebtidstart=i; break; }
       }
      ebtidstart++;
      for(i=0; i<15; i++)
       {
        printf("%c", puffer[ebtidstart+i]);
        if(puffer[ebtidstart+i+1] == ';') break;
       }
      printf(" <A HREF=\"https://www.eurobilltracker.com/my_notes/?tab=3;step=2;serial=%c%c%c%c%c%c%c%c%c%c%c%c;denomination=%d\" target=_blank>click here to edit (will open in new window)</A>", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11], n);
      printf("<BR>\n");
     }

    // if the short code value is not correct, print it
    if(sc==1)
     {
      printf("printer short code seems to be wrong: %d Euro note ", n);
      printf("<b>%c%c%c%c%c%c</b> - ", puffer[t], puffer[t+1], puffer[t+2], puffer[t+3], puffer[t+4], puffer[t+5]);
      printf("<b>%c%c%c%c%c%c%c%c%c%c%c%c</b>, ", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11]);
      printf("EBT notes id: ");
      ebtidstart=0;
      b=0;
      // find the position of the semicolon before the ebt notes id
      for(i=0; i<1024; i++)
       {
        if(puffer[i] == ';') b++;
        if(b == ( scount-4 )) { ebtidstart=i; break; }
       }
      ebtidstart++;
      for(i=0; i<15; i++)
       {
        printf("%c", puffer[ebtidstart+i]);
        if(puffer[ebtidstart+i+1] == ';') break;
       }
      printf(" <A HREF=\"https://www.eurobilltracker.com/my_notes/?tab=3;step=2;serial=%c%c%c%c%c%c%c%c%c%c%c%c;denomination=%d\" target=_blank>click here to edit (will open in new window)</A>", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11], n);
      printf("<BR>");
      tcount++;
     }

    /* check if there is a not valid character in the short code
       example: L018K1 is not correct (highest allowed letter at the fifth position is J)
                L017I2 is not correct (highest allowed letter at the fifth position is H */
    if((int) puffer[t+4] > fn)
     {
      printf("fifth character of short code looks wrong: %d Euro note ", n);
      printf("%c%c%c%c<FONT COLOR=red><b>%c</b></FONT>", puffer[t], puffer[t+1], puffer[t+2], puffer[t+3], puffer[t+4]);
      if(((int) puffer[t+5] > ms) && ((int) puffer[t+4] > fn)) printf("<FONT COLOR=red><b>%c</b></FONT>", puffer[t+5]);
      else printf("%c", puffer[t+5]);
      printf(" %c%c%c%c%c%c%c%c%c%c%c%c", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11]);
      if((sc==1) || (f==0)) { printf("<FONT COLOR=red> please take also care one line above</FONT>"); }
      else
       {
        tcount++;
        printf(" EBT notes id: ");
        ebtidstart=0;
        b=0;
        // find the position of the semicolon before the ebt notes id
        for(i=0; i<1024; i++)
         {
          if(puffer[i] == ';') b++;
          if(b == ( scount-4 )) { ebtidstart=i; break; }
         }
        ebtidstart++;
        for(i=0; i<15; i++)
         {
          printf("%c", puffer[ebtidstart+i]);
          if(puffer[ebtidstart+i+1] == ';') break;
         }
        printf(" <A HREF=\"https://www.eurobilltracker.com/my_notes/?tab=3;step=2;serial=%c%c%c%c%c%c%c%c%c%c%c%c;denomination=%d\" target=_blank>click here to edit (will open in new window)</A>", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11], n);
       }
      if(f != 0) printf(", highest valid letter at fifth position for this short code is a <FONT COLOR=red><b>%c</b></FONT>\n", fn);
      else printf(", take also care about the fifth position, it might be wrong\n");
     }

    // check for a valid value of the sixt position in the short code
    if((int) puffer[t+5] > ms)
     {
      if((int) puffer[t+4] > fn) {}
      else
       {
        printf("sixth character of short code looks wrong %3d Euro note ", n);
        printf("%c%c%c%c%c<FONT COLOR=red><b>%c</b></FONT> ", puffer[t], puffer[t+1], puffer[t+2], puffer[t+3], puffer[t+4], puffer[t+5]);
        printf("%c%c%c%c%c%c%c%c%c%c%c%c", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11]);
        if((sc==1) || (f==0)) { printf("   !!!!!! please take also care one line above !!!!!!"); }
        else
         {
          tcount++;
          printf(" EBT notes id: ");
          ebtidstart=0;
          b=0;
          // find the position of the semicolon before the ebt notes id
          for(i=0; i<1024; i++)
           {
            if(puffer[i] == ';') b++;
            if(b == ( scount-4 )) { ebtidstart=i; break; }
           }
          ebtidstart++;
          for(i=0; i<15; i++)
           {
            printf("%c", puffer[ebtidstart+i]);
            if(puffer[ebtidstart+i+1] == ';') break;
           }
          printf(" <A HREF=\"https://www.eurobilltracker.com/my_notes/?tab=3;step=2;serial=%c%c%c%c%c%c%c%c%c%c%c%c;denomination=%d\" target=_blank>click here to edit (will open in new window)</A>", puffer[sn], puffer[sn+1], puffer[sn+2], puffer[sn+3], puffer[sn+4], puffer[sn+5], puffer[sn+6], puffer[sn+7], puffer[sn+8], puffer[sn+9], puffer[sn+10], puffer[sn+11], n);
         }
        }
       if(f != 0) printf(", highest valid value at sixth position for this short code is a <FONT COLOR=red><b>%c</b></FONT>\n", ms); 
       else printf(", take also care about the sixth position, it might be wrong\n");
      }
   if((sc==1) || (f==0) || ((int) puffer[t+5] > ms) || ((int) puffer[t+4] > fn)) printf("<HR>");
   }

  // print a summary
  printf("%d unknown combination", fcount);
  if(fcount != 1) printf("s");
  if(tcount > 0)
   {
    printf(", maybe %d typing error", tcount);
    if(tcount != 1) printf("s");
    printf(" at the printer codes");
   }
  printf(", %d notes total<P>\n", c);

  // time calculation
  time2 = clock ();
  thou  = (time2-time1) * 1000 / CLOCKS_PER_SEC;
  sec   = thou / 1000;
  thou -= sec * 1000;
  printf ("Checking of notes took %ld.%03ld seconds</BODY>\n</HTML>\n", sec, thou);
  fclose(quelle);
  return EXIT_SUCCESS;
 }
