#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

/* variables from ebtnotescheck.c or htmlebtnotescheck.c */
extern int c, en, f, fn, i, ms, n, sc, scount, sn, t;
extern char puffer[1024];

/* the short code is stored in a string, need this to get the int */
char shortcodewert[4];
/* counter for finding the semicolon before the short code */
int a;

/* function notescheck, progtype defines if normal (1) or HTML (2) */
void notescheck(int progtype)
   {
    // count how many notes we have already checked and give every 100000 notes a status message
    c++;
    if((c%100000) == 0)
     {
      printf("Status: already %7d notes checked", c);
      if(progtype==1) printf("\n");
       else printf("<HR>");
     }

    /* make sure that all needed variables are set to zero */
    a=0; f=0; i=0; n=0; t=0;
    en=0;
    sc=0;
    scount=0;
    shortcodewert[0]='0'; shortcodewert[1]='0'; shortcodewert[2]='0'; shortcodewert[3]='\n'; 

    // usually we assume that the highest code for the fifth position of the printer code is a J
    fn=74;
    // usually we assume that the highest code for the sixth position of the printer code is a 6
    ms=54;

    /* find out how many semicolons the current line has and store it into scount
       it could be that in the note comment a semicolon exist so we need them all */
    for(i=0; i<1024; i++)
     {
      if(puffer[i] == '\0') break;
      if(puffer[i] == ';') scount++;
     }
    
    /* identify what value the note has and store it into n
       store in sn the beginning position of the serial number */
    if((puffer[0] == '5') && (puffer[1] == ';')) { sn=7; n=5; } /* y=2; } */
    if((puffer[0] == '1') && (puffer[2] == ';')) { sn=8; n=10; } /* y=3; } */
    if((puffer[0] == '2') && (puffer[2] == ';')) { sn=8; n=20; } /* y=3; } */
    if((puffer[0] == '5') && (puffer[2] == ';')) { sn=8; n=50; } /* y=3; } */
    if((puffer[0] == '1') && (puffer[3] == ';')) { sn=9; n=100; } /* y=4; } */
    if((puffer[0] == '2') && (puffer[3] == ';')) { sn=9; n=200; } /* y=4; } */
    if((puffer[0] == '5') && (puffer[3] == ';')) { sn=9; n=500; } /* y=4; } */

    // convert the char year into an int, for later if we ever need this
    // year = 2000 + ((int) puffer[y+2]-48)*10 + ((int) puffer[y+3]-48);

    // find out the position of the semicolon before the short code and store it into t
    for(i=sn; i<1024; i++)
     {
      if(puffer[i] == ';') a++;
      if(a == ( scount-7 )) { t=i; break; }
     }

    /* increment t so we have now the first sign of the short code */
    t++;

    /* move the 3 digits into shortcodewert
       example: P015A1 = 015 */
    shortcodewert[0]=puffer[t+1];
    shortcodewert[1]=puffer[t+2];
    shortcodewert[2]=puffer[t+3];

    /* now begin with the checks
       first check: combination, if valid set f to 1
       second check: value of the short code, if it is wrong set sc to 1 */

    /* 5 D/L: D001 */
    if((puffer[t] == 'D') && (puffer[sn] == 'L') && (n==5))   { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 10 D/L: D001 */
    if((puffer[t] == 'D') && (puffer[sn] == 'L') && (n==10))  { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 20 D/L: D001 */
    if((puffer[t] == 'D') && (puffer[sn] == 'L') && (n==20))  { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=70; ms=53; }

    /* 50 D/L: D001 */
    if((puffer[t] == 'D') && (puffer[sn] == 'L') && (n==50))  { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=69; ms=52; }

    /* 100 D/L: D001,D002 */
    if((puffer[t] == 'D') && (puffer[sn] == 'L') && (n==100)) { f=1; if(atoi(shortcodewert) > 2) sc=1; fn=69; ms=52; }

    /* 200 D/L: D001 */
    if((puffer[t] == 'D') && (puffer[sn] == 'L') && (n==200)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=69; ms=52; }

    /* 500 D/L: D001 */
    if((puffer[t] == 'D') && (puffer[sn] == 'L') && (n==500)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=69; ms=52; }

    /* 5 E/E: these exists in 2002 and Europa series */
    if((puffer[t] == 'E') && (puffer[sn] == 'E') && (n==5))
     {
     if(isdigit(puffer[sn+1]))
      {
       /* 5 E/E: E010 */
       f=1;
       if(atoi(shortcodewert) != 10) sc=1;
      }
     else
      {
       /* 5 E/E Europa: E001 */
       f=1;
       if(atoi(shortcodewert) > 1) sc=1;
      }
     }

    // 10 E/E Europa: E001,E002,E003,E004,E005,E006,E007,E008
    if((puffer[t] == 'E') && (puffer[sn] == 'E') && (n==10)) { f=1; if(
      (atoi(shortcodewert) > 8)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 20 E/E Europa: E001,E002,E003,E004,E005,E006,E007,E008,E009,E010,E011,E012,E013,E014
    if((puffer[t] == 'E') && (puffer[sn] == 'E') && (n==20)) { f=1; if(
      (atoi(shortcodewert) > 14)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 50 E/E Europa: E001,E002,E003,E004,E005,E006,E007,E008,E009,E010,E011,E012,E013,E014,E015,
                      E016,E017,E018,E019,E020,E021 */
    if((puffer[t] == 'E') && (puffer[sn] == 'E') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 21)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 100 E/E Europa: E001,E002,E003,E004,E005,E006,E008,E009,E010,E011,E012,E013,E014,E015,E016,
                       E017,E018,E019,E020 */
    if((puffer[t] == 'E') && (puffer[sn] == 'E') && (n==100)) { f=1; if(
      (atoi(shortcodewert) > 6) &&
      ((atoi(shortcodewert) < 8) || (atoi(shortcodewert) > 20))
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 200 E/E Europa: E001,E002,E003,E004,E005,E006,E007,E008,E009,E010
    if((puffer[t] == 'E') && (puffer[sn] == 'E') && (n==200)) { f=1; if(
      (atoi(shortcodewert) > 10)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 E/F: E009 */
    if((puffer[t] == 'E') && (puffer[sn] == 'F') && (n==5)) { f=1; if((atoi(shortcodewert) != 9)) sc=1; }

    /* 5 E/G: E009,E010 */
    if((puffer[t] == 'E') && (puffer[sn] == 'G') && (n==5)) { f=1; if((atoi(shortcodewert) < 9) || (atoi(shortcodewert) > 10)) sc=1; }

    /* 5 E/H: E010 */
    if((puffer[t] == 'E') && (puffer[sn] == 'H') && (n==5)) { f=1; if(atoi(shortcodewert) != 10) sc=1; }

    /* 20 E/H: E003,E004 */
    if((puffer[t] == 'E') && (puffer[sn] == 'H') && (n==20)) { f=1; if((atoi(shortcodewert) < 3) || (atoi(shortcodewert) > 4)) sc=1; fn=73; }

    /* 5 E/L: E001,E010,E011 */
    if((puffer[t] == 'E') && (puffer[sn] == 'L') && (n==5)) { f=1; if(
     (atoi(shortcodewert) != 1) && ((atoi(shortcodewert) < 10) || (atoi(shortcodewert) > 11))) sc=1; }

    /* 20 E/L: E003,E005,E006 */
    if((puffer[t] == 'E') && (puffer[sn] == 'L') && (n==20)) { f=1; if(
     (atoi(shortcodewert) != 3) && ((atoi(shortcodewert) < 5) || (atoi(shortcodewert) > 6))) sc=1; fn=73; }

    /* 5 E/P: E002,E003,E004,E005,E006,E007,E008,E009,E010 */
    if((puffer[t] == 'E') && (puffer[sn] == 'P') && (n==5)) { f=1; if((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 10)) sc=1; }

    /* 20 E/U: E001,E002 */
    if((puffer[t] == 'E') && (puffer[sn] == 'U') && (n==20)) { f=1; if(atoi(shortcodewert) > 2) sc=1; fn=73; }

    /* 100 E/U: E001 */
    if((puffer[t] == 'E') && (puffer[sn] == 'U') && (n==100)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=72; ms=53; }

    /* 10 E/X: E002,E003,E004,E005,E006,E007,E008,E009 */
    if((puffer[t] == 'E') && (puffer[sn] == 'X') && (n==10)) { f=1; if((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 9)) sc=1; }

    /* 20 E/X: E008,E009,E010 */
    if((puffer[t] == 'E') && (puffer[sn] == 'X') && (n==20)) { f=1; if((atoi(shortcodewert) < 8) || (atoi(shortcodewert) > 10)) sc=1; fn=73; }

    /* 50 E/X: E001,E002,E003,E004,E005 */
    if((puffer[t] == 'E') && (puffer[sn] == 'X') && (n==50)) { f=1; if((atoi(shortcodewert) > 5)) sc=1; fn=72; ms=53; }

    /* 100 E/X: E002,E003,E004,E005 */
    if((puffer[t] == 'E') && (puffer[sn] == 'X') && (n==100)) { f=1; if(
     (atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 5)
     ) sc=1; fn=72; ms=53; }

    /* 200 E/X: E001,E002,E003,E004 */
    if((puffer[t] == 'E') && (puffer[sn] == 'X') && (n==200)) { f=1; if(atoi(shortcodewert) > 4) sc=1; fn=72; ms=53; }

    // 10 F/F Europa: F001,F002,F003,F004,F005,F006
    if((puffer[t] == 'F') && (puffer[sn] == 'F') && (n==10)) { f=1; if(
      (atoi(shortcodewert) > 6)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 20 F/F Europa: F001,F002,F003
    if((puffer[t] == 'F') && (puffer[sn] == 'F') && (n==20)) { f=1; if(
      (atoi(shortcodewert) > 3)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 5 F/N: F001,F002,F003,F004,F005
    if((puffer[t] == 'F') && (puffer[sn] == 'N') && (n==5)) { f=1; if(atoi(shortcodewert) > 5) sc=1; }

    // 10 F/N: F001,F002,F003,F004,F005,F006,F007,F008,F009,F010,F011,F012,F014,F015,F016,F018,F020
    if((puffer[t] == 'F') && (puffer[sn] == 'N') && (n==10)) { f=1; if(
     (atoi(shortcodewert) > 12) && ((atoi(shortcodewert) < 14) || (atoi(shortcodewert) > 16)) &&
     (atoi(shortcodewert) != 18) && (atoi(shortcodewert) != 20)) sc=1; fn=73; }

    // 20 F/N: F001,F002,F003
    if((puffer[t] == 'F') && (puffer[sn] == 'N') && (n==20)) { f=1; if(atoi(shortcodewert) > 3) sc=1; fn=72; ms=53; }

    /* 50 F/N: F001 */
    if((puffer[t] == 'F') && (puffer[sn] == 'N') && (n==50)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=72; ms=53; }

    /* 100 F/N: F001,F002,F003,F004,F005,F006,F007,F010,F011,F012 */
    if((puffer[t] == 'F') && (puffer[sn] == 'N') && (n==100)) { f=1; if(
     (atoi(shortcodewert) > 7) && (atoi(shortcodewert) != 10) && (atoi(shortcodewert) != 11) && (atoi(shortcodewert) != 12)) sc=1; fn=71; ms=53; }

    /* 500 F/N: F001,F002,F003,F005,F007,F008 */
    if((puffer[t] == 'F') && (puffer[sn] == 'N') && (n==500)) { f=1; if(
     (atoi(shortcodewert) > 3) && (atoi(shortcodewert) != 5) && (atoi(shortcodewert) != 7) && (atoi(shortcodewert) != 8)) sc=1;
     if(atoi(shortcodewert) < 3) fn=70; ms=52;
     if(atoi(shortcodewert) > 2) fn=72; ms=53; }

    /* 5 F/P: F003 */
    if((puffer[t] == 'F') && (puffer[sn] == 'P') && (n==5)) { f=1; if(atoi(shortcodewert) != 3) sc=1; }

    /* 500 F/P: F001 */
    if((puffer[t] == 'F') && (puffer[sn] == 'P') && (n==500)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=70; ms=52; }

    /* 50 F/S: F002,F003,F004,F005,F006,F007,F008 */
    if((puffer[t] == 'F') && (puffer[sn] == 'S') && (n==50)) { f=1; if((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 8)) sc=1; fn=72; ms=53; }

    /* 500 F/T: F001 */
    if((puffer[t] == 'F') && (puffer[sn] == 'T') && (n==500)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=70; ms=52; }

    /* 10 F/Y: F001 */
    if((puffer[t] == 'F') && (puffer[sn] == 'Y') && (n==10)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=73; }

    /* 20 G/E: G010,G012,G013,G014,G015 */
    if((puffer[t] == 'G') && (puffer[sn] == 'E') && (n==20)) { f=1; if(
     (atoi(shortcodewert) != 10) && ((atoi(shortcodewert) < 12) || (atoi(shortcodewert) > 15))) sc=1; fn=73; }

    /* 20 G/F: G007,G008,G009,G010,G012,G013,G014 */
    if((puffer[t] == 'G') && (puffer[sn] == 'F') && (n==20)) { f=1; if(
     ((atoi(shortcodewert) < 7) || (atoi(shortcodewert) > 10)) && ((atoi(shortcodewert) < 12) || (atoi(shortcodewert) > 14))) sc=1; fn=73; }

    /* 20 G/G: G007,G008,G009,G010,G012,G013,G014 */
    if((puffer[t] == 'G') && (puffer[sn] == 'G') && (n==20)) { f=1; if(
     ((atoi(shortcodewert) < 7) || (atoi(shortcodewert) > 10)) && ((atoi(shortcodewert) < 12) || (atoi(shortcodewert) > 14))) sc=1; fn=73; }

    /* 20 G/H: G007,G008,G009,G010,G012,G013,G014,G015 */
    if((puffer[t] == 'G') && (puffer[sn] == 'H') && (n==20)) { f=1; if(
     ((atoi(shortcodewert) < 7) || (atoi(shortcodewert) > 10)) && ((atoi(shortcodewert) < 12) || (atoi(shortcodewert) > 15))) sc=1; fn=73; }

    /* 20 G/L: G005,G006,G010,G011,G012,G014,G015 */
    if((puffer[t] == 'G') && (puffer[sn] == 'L') && (n==20)) { f=1; if(((atoi(shortcodewert) < 5) || (atoi(shortcodewert) > 6)) &&
     ((atoi(shortcodewert) < 10) || (atoi(shortcodewert) > 12)) && ((atoi(shortcodewert) < 14) || (atoi(shortcodewert) > 15))) sc=1; fn=73; }

    /* 200 G/N: G001 */
    if((puffer[t] == 'G') && (puffer[sn] == 'N') && (n==200)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=70; ms=52; }

    /* 5 G/P: G001,G003,G004,G006,G007 */
    if((puffer[t] == 'G') && (puffer[sn] == 'P') && (n==5)) { f=1; if((atoi(shortcodewert) > 1) &&
     ((atoi(shortcodewert) < 3) || (atoi(shortcodewert) > 4)) && ((atoi(shortcodewert) < 6) || (atoi(shortcodewert) > 7))) sc=1; }

    /* 10 G/P: G001,G006,G007,G008,G009,G010,G011,G013,G014 */
    if((puffer[t] == 'G') && (puffer[sn] == 'P') && (n==10)) { f=1; if ((atoi(shortcodewert) > 1) &&
     ((atoi(shortcodewert) < 6) || (atoi(shortcodewert) > 11)) && ((atoi(shortcodewert) < 13) || (atoi(shortcodewert) > 14))) sc=1; }

    /* 20 G/P: G001,G002,G003,G005,G006,G007,G008,G009,G010,G011,G012,G014,G015 */
    if((puffer[t] == 'G') && (puffer[sn] == 'P') && (n==20)) { f=1; if((atoi(shortcodewert) > 3) &&
     ((atoi(shortcodewert) < 5) || (atoi(shortcodewert) > 12)) && ((atoi(shortcodewert) < 14) || (atoi(shortcodewert) > 15))) sc=1; fn=73;
     if(atoi(shortcodewert) < 4) ms=53; }

    /* 50 G/P: G001,G002,G004,G005,G006,G007,G008,G009,G010,G011,G016,G017,G019,G020,G021,G023,G024,
               G025,G026 */
    if((puffer[t] == 'G') && (puffer[sn] == 'P') && (n==50)) { f=1; if(
     (atoi(shortcodewert) > 2) && ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 11)) && ((atoi(shortcodewert) < 16) || (atoi(shortcodewert) > 17)) &&
     ((atoi(shortcodewert) < 19) || (atoi(shortcodewert) > 21)) && ((atoi(shortcodewert) < 23) || (atoi(shortcodewert) > 26))) sc=1; fn=72; ms=53; }

    /* 100 G/P: G001,G002,G003,G008,G009 */
    if((puffer[t] == 'G') && (puffer[sn] == 'P') && (n==100)) { f=1; if(
     (atoi(shortcodewert) > 3) && ((atoi(shortcodewert) < 8) || (atoi(shortcodewert) > 9))) sc=1;
     if(atoi(shortcodewert) < 4) { fn=70; ms=52; }
     if(atoi(shortcodewert) > 7) { fn=72; ms=53; } }

    /* 200 G/P: G001 */
    if((puffer[t] == 'G') && (puffer[sn] == 'P') && (n==200)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=70; ms=52; }

    /* 10 G/V: G002,G003,G004,G005 */
    if((puffer[t] == 'G') && (puffer[sn] == 'V') && (n==10)) { f=1; if((atoi(shortcodewert) < 2) ||(atoi(shortcodewert) > 5)) sc=1; fn=73; }

    /* 10 G/X: G015,G016,G017 */
    if((puffer[t] == 'G') && (puffer[sn] == 'X') && (n==10)) { f=1; if((atoi(shortcodewert) < 15) || (atoi(shortcodewert) > 17)) sc=1; fn=73; }

    /* 50 G/X: G027,G028,G029,G030,G031,G032,G033,G034,G035,G036,G037,G038,G039,G040,G041,G042,G043,
               G044 */
    if((puffer[t] == 'G') && (puffer[sn] == 'X') && (n==50)) { f=1; if(((atoi(shortcodewert) < 27) || (atoi(shortcodewert) > 44))) sc=1; fn=72; ms=53; }

    /* 50 G/Y: G013,G014 */
    if((puffer[t] == 'G') && (puffer[sn] == 'Y') && (n==50)) { f=1; if((atoi(shortcodewert) < 13) || (atoi(shortcodewert) > 14)) sc=1; fn=72; ms=53; }

    /* 100 G/Y: G006 */
    if((puffer[t] == 'G') && (puffer[sn] == 'Y') && (n==100)) { f=1; if(atoi(shortcodewert) != 6) sc=1; fn=70; ms=52; }

    /* 20 H/L: H006*/
    if((puffer[t] == 'H') && (puffer[sn] == 'L') && (n==20)) { f=1; if(atoi(shortcodewert) != 6) sc=1; fn=73; ms=53; }

    /* 50 H/L: H005,H006,H007 */
    if((puffer[t] == 'H') && (puffer[sn] == 'L') && (n==50)) { f=1; if((atoi(shortcodewert) < 5) || (atoi(shortcodewert) > 7)) sc=1; fn=72; ms=53; }

    /* 100 H/L: H001,H002 */
    if((puffer[t] == 'H') && (puffer[sn] == 'L') && (n==100)) { f=1; if(atoi(shortcodewert) > 2) sc=1; fn=72; ms=53; }

    /* 20 H/M: H004,H005 */
    if((puffer[t] == 'H') && (puffer[sn] == 'M') && (n==20)) { f=1; if((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 5)) sc=1; fn=73; ms=53; }

    /* 50 H/M: H001,H002,H003,H004,H007,H008 */
    if((puffer[t] == 'H') && (puffer[sn] == 'M') && (n==50)) { f=1; if((atoi(shortcodewert) > 4) && ((atoi(shortcodewert) < 7) || (atoi(shortcodewert) > 8))) sc=1; fn=72; ms=53; }

    /* 50 H/P: H016 */
    if((puffer[t] == 'H') && (puffer[sn] == 'P') && (n==50)) { f=1; if(atoi(shortcodewert) != 16) sc=1; fn=72; ms=53; }

    /* 20 H/T: H001,H002,H003,H004 */
    if((puffer[t] == 'H') && (puffer[sn] == 'T') && (n==20)) { f=1; if(atoi(shortcodewert) > 4) sc=1; ms=53; }

    /* 5 J/S: J001,J002,J003,J004,J005 */
    if((puffer[t] == 'J') && (puffer[sn] == 'S') && (n==5)) { f=1; if(atoi(shortcodewert) > 5) sc=1; }

    /* 10 J/S: J001,J002,J003,J004,J005,J006,J007,J008,J009 */
    if((puffer[t] == 'J') && (puffer[sn] == 'S') && (n==10)) { f=1; if(atoi(shortcodewert) > 9) sc=1; fn=73; }

    /* 20 J/S: J001,J002,J003,J004,J005,J006,J007,J008,J009,J010,J011,J012,J013,J014,J015,J016,J017,
               J018,J019,J020,J021,J022,J023,J024,J026,J027,J028,J029,J030,J031,J032,J033,J034,J035,
               J036 */
    if((puffer[t] == 'J') && (puffer[sn] == 'S') && (n==20)) { f=1; if(atoi(shortcodewert) > 36) sc=1; fn=73; }

    /* 50 J/S: J001,J002,J003,J004,J005,J006,J007,J008,J009,J010,J011,J012,J013,J014,J015,J016,J017,
               J018,J019,J020,J021,J022,J023,J024,J026,J027,J028,J029,J030,J031,J032,J033,J034,J035,
               J036,J037,J038,J039,J040,J041,J042,J043,J044,J045,J046,J047,J048,J049,J050,J051,J052,
               J053,J054,J055,J056,J057,J058,J059,J060,J061,J062,J063,J064,J065,J066,J067,J068,J069,
               J070,J072,J073,J074,J075,J076,J077,J078,J079,J080,J081,J083,J084,J085,J086,J087,J088,
               J089,J090,J091,J092,J093,J095,J096,J097,J098,J100,J102 */
    if((puffer[t] == 'J') && (puffer[sn] == 'S') && (n==50)) { f=1; if((atoi(shortcodewert) > 24) &&
     ((atoi(shortcodewert) < 26) || (atoi(shortcodewert) > 70)) && ((atoi(shortcodewert) < 72) || (atoi(shortcodewert) > 81)) &&
     ((atoi(shortcodewert) < 83) || (atoi(shortcodewert) > 93)) && ((atoi(shortcodewert) < 95) || (atoi(shortcodewert) > 98)) &&
     (atoi(shortcodewert) != 100) && (atoi(shortcodewert) != 102)) sc=1; fn=72; ms=53; }

    /* 100 J/S: J001,J002,J003,J004,J005,J006,J007,J008,J009,J010,J011,J012,J013,J014,J015,J016,J017,
                J018,J019,J020,J021,J022,J023,J024,J025,J028,J029,J030,J031,J032,J033,J034 */
    if((puffer[t] == 'J') && (puffer[sn] == 'S') && (n==100)) { f=1; if((atoi(shortcodewert) > 25) &&
     ((atoi(shortcodewert) < 28) || (atoi(shortcodewert) > 34))) sc=1; fn=72; ms=53; }

    /* 200 J/S: J001 */
    if((puffer[t] == 'J') && (puffer[sn] == 'S') && (n==200)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=72; ms=53; }

    /* 500 J/S: J001 */
    if((puffer[t] == 'J') && (puffer[sn] == 'S') && (n==500)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=52; }

    /* 5 K/T: K001,K002,K003 */
    if((puffer[t] == 'K') && (puffer[sn] == 'T') && (n==5)) { f=1; if(atoi(shortcodewert) > 3) sc=1; }

    /* 10 K/T: K001,K002,K003,K004,K005,K006,K007 */
    if((puffer[t] == 'K') && (puffer[sn] == 'T') && (n==10)) { f=1; if(atoi(shortcodewert) > 7) sc=1; }

    /* 20 K/T: K001,K002,K003,K004 */
    if((puffer[t] == 'K') && (puffer[sn] == 'T') && (n==20)) { f=1; if(atoi(shortcodewert) > 4) sc=1; fn=73; ms=53; }

    /* 50 K/T: K001 */
    if((puffer[t] == 'K') && (puffer[sn] == 'T') && (n==50)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=72; ms=53; }

    /* 100 K/T: K001 */
    if((puffer[t] == 'K') && (puffer[sn] == 'T') && (n==100)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 5 L/U: L001,L002,L003,L004,L005,L006,L007,L008,L009,L010,L011,L012,L013,L014,L015,L016,L017,
              L018,L019,L020,L021,L022,L023,L024,L025,L026,L027,L028,L029,L030,L031,L032 */
    if((puffer[t] == 'L') && (puffer[sn] == 'U') && (n==5)) { f=1; if(atoi(shortcodewert) > 32) sc=1;
     if(atoi(shortcodewert) < 18) { fn=72; ms=52; } }

    /* 10 L/U: L004,L005,L006,L007,L008,L009,L010,L011,L012,L013,L014,L015,L016,L017,L018,L019,L020,
               L021,L022,L023,L024,L025,L026,L027,L028,L029,L030,L031,L032,L033,L034,L035,L036,L037,
               L038,L039,L040,L041,L042,L043,L044,L045,L046,L047,L048,L049,L050,L051,L052,L053,L056 */
    if((puffer[t] == 'L') && (puffer[sn] == 'U') && (n==10)) { f=1; if(
     ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 53)) && (atoi(shortcodewert) != 56)) sc=1;
     if(atoi(shortcodewert) < 11) { fn=71; ms=52; }
     if((atoi(shortcodewert) > 10) && (atoi(shortcodewert) < 22)) { fn=72; ms=52; }
     if((atoi(shortcodewert) > 21) && (atoi(shortcodewert) < 25)) fn=73;
     if((atoi(shortcodewert) > 24) && (atoi(shortcodewert) < 27)) { fn=72; ms=52; }
     if(atoi(shortcodewert) == 27) fn=73;
     if((atoi(shortcodewert) > 27) && (atoi(shortcodewert) < 51)) { fn=72; ms=52; }
     if(atoi(shortcodewert) > 51) fn=73; }

    /* 20 L/U: L001,L002,L003,L004,L005,L006,L007,L008,L009,L010,L011,L012,L013,L014,L015,L016,L017,
               L018,L019,L020,L021,L022,L023,L024,L025,L026,L027,L028,L029,L030,L031,L032,L033,L034,
               L035,L036,L037,L038,L039,L040,L041,L042,L043,L044,L045,L046,L047,L048,L050,L051,L052,
               L053,L054,L055,L056,L057,L058,L059,L060,L061,L062,L063,L064,L065,L066,L067,L068,L069,
               L070,L071,L072,L073,L074,L075,L076,L077,L078,L079,L080,L081,L082,L083,L084,L085,L086,
               L087,L088 */
    if((puffer[t] == 'L') && (puffer[sn] == 'U') && (n==20)) { f=1; if(atoi(shortcodewert) > 88) sc=1;
     if(atoi(shortcodewert) < 65) { fn=71; ms=52; }
     if((atoi(shortcodewert) > 64) && (atoi(shortcodewert) < 69)) fn=73;
     if((atoi(shortcodewert) > 68) && (atoi(shortcodewert) < 75)) { fn=71; ms=52; }
     if((atoi(shortcodewert) > 74) && (atoi(shortcodewert) < 80)) fn=73;
     if((atoi(shortcodewert) > 79) && (atoi(shortcodewert) < 82)) { fn=72; ms=52; }
     if(atoi(shortcodewert) > 81) fn=73; }

    // 50 L/U: L002,L003,L004,L005,L006,L007,L008,L009,L010
    if((puffer[t] == 'L') && (puffer[sn] == 'U') && (n==50)) { f=1; if((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 10)) sc=1; fn=71; ms=51; }

    // 5 M/M Europa: M001,M002,M003,M004,M005,M006,M007,M008,M009,M010
    if((puffer[t] == 'M') && (puffer[sn] == 'M') && (n==5)) { f=1; if(atoi(shortcodewert) > 10) sc=1;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 10 M/M Europa: M001 */
    if((puffer[t] == 'M') && (puffer[sn] == 'M') && (n==10)) { f=1; if(atoi(shortcodewert) > 1) sc=1;
      fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 20 M/M Europa: M001,M002,M003,M004,M005,M006,M007 */
    if((puffer[t] == 'M') && (puffer[sn] == 'M') && (n==20)) { f=1; if(atoi(shortcodewert) > 7) sc=1;
      fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 50 M/M Europa: M001,M002,M003,M004,M005,M006,M007,M008 */
    if((puffer[t] == 'M') && (puffer[sn] == 'M') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 8)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     } 

    /* 5 M/V: M001,M002,M003,M004,M005,M006,M007,M008,M009,M010,M011,M012,M013,M014,M015,M016 */
    if((puffer[t] == 'M') && (puffer[sn] == 'V') && (n==5)) { f=1; if(atoi(shortcodewert) > 16) sc=1; }

    /* 10 M/V: M001,M002,M003 */
    if((puffer[t] == 'M') && (puffer[sn] == 'V') && (n==10)) { f=1; if(atoi(shortcodewert) > 3) sc=1; fn=73; }

    /* 20 M/V: M001,M002,M003,M004,M005,M006,M007,M008,M009,M010,M011,M012,M013,M014,M015,M016,M017,
               M018,M019,M020,M021,M022,M023,M024,M025 */
    if((puffer[t] == 'M') && (puffer[sn] == 'V') && (n==20)) { f=1; if(atoi(shortcodewert) > 25) sc=1; fn=73; ms=53; }

    /* 50 M/V: M001,M002,M003,M004,M005,M006,M007,M008,M009,M010,M011,M012,M013,M014,M015,M016,M017,
               M018,M019,M020,M021,M022,M023,M024,M025,M026,M027,M028,M029,M030,M031,M032,M033,M034,
               M035,M036,M037,M038,M039,M040,M041,M042,M043,M044,M045,M046,M047,M048,M049,M050,M051,
               M052,M053,M054,M055,M056,M057,M058
       M043 to M046 have printed MO43,MO44,MO45 or MO46 on it, but here we see the O as zero */
    if((puffer[t] == 'M') && (puffer[sn] == 'V') && (n==50)) { f=1; if((atoi(shortcodewert) > 58)) sc=1; fn=72; ms=53; }

    /* 100 M/V: M001,M002,M004,M005,M006,M007 */
    if((puffer[t] == 'M') && (puffer[sn] == 'V') && (n==100)) { f=1; if(
      (atoi(shortcodewert) > 2) && ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 7))
     ) sc=1; fn=71; ms=53; }

    /* 5 N/N Europa: N004,N005,N006,N008,N009,N010,N011,N014,N015,N016,N017,N018,N019,N020,N021,N022,
                     N023,N024 */
    if((puffer[t] == 'N') && (puffer[sn] == 'N') && (n==5)) { f=1; if(
     ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 6)) &&
     ((atoi(shortcodewert) < 8) || (atoi(shortcodewert) > 11)) &&
     ((atoi(shortcodewert) < 14) || (atoi(shortcodewert) > 24))
     ) sc=1;
     if(isdigit(puffer[sn+1])) en=1;
     }

    /* 10 N/N Europa: N002,N005,N006,N008,N010,N011,N012,N013,N015,N018,N019 */
    if((puffer[t] == 'N') && (puffer[sn] == 'N') && (n==10)) { f=1; if(
     (atoi(shortcodewert) != 2) &&
     ((atoi(shortcodewert) < 5) || (atoi(shortcodewert) > 6)) &&
     (atoi(shortcodewert) != 8) &&
     ((atoi(shortcodewert) < 10) || (atoi(shortcodewert) > 13)) &&
     (atoi(shortcodewert) != 15) &&
     ((atoi(shortcodewert) < 18) || (atoi(shortcodewert) > 19))
     ) sc=1; fn=73;
     if(isdigit(puffer[sn+1])) en=1;
     }

    /* 20 N/N Europa: N001,N004,N005,N007,N008,N009,N010,N011,N012 */
    if((puffer[t] == 'N') && (puffer[sn] == 'N') && (n==20)) { f=1; if(
     (atoi(shortcodewert) != 1) &&
     ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 5)) &&
     ((atoi(shortcodewert) < 7) || (atoi(shortcodewert) > 12))
     ) sc=1; fn=73;
     if(isdigit(puffer[sn+1])) en=1;
     }

    // 50 N/N Europa: N001
    if((puffer[t] == 'N') && (puffer[sn] == 'N') && (n==50)) { f=1; if(
      (atoi(shortcodewert) != 1)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 100 N/N Europa: N001,N004
    if((puffer[t] == 'N') && (puffer[sn] == 'N') && (n==100)) { f=1; if(
      (atoi(shortcodewert) != 1) &&
      (atoi(shortcodewert) != 4)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 200 N/N Europa: N001,N002,N003,N004,N005
    if((puffer[t] == 'N') && (puffer[sn] == 'N') && (n==200)) { f=1; if(
      (atoi(shortcodewert) > 5)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 N/Y: N001 */
    if((puffer[t] == 'N') && (puffer[sn] == 'Y') && (n==5)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 10 N/Y: N001,N002,N003,N004,N005,N006,N007,N008,N009,N010,N011,N012,N013,N014,N015,N016,N017,
               N018,N019,N020,N021,N022,N023,N024,N025,N026,N027,N028,N029,N030,N031,N032,N033,N034,
               N036,N037 */
    if((puffer[t] == 'N') && (puffer[sn] == 'Y') && (n==10)) { f=1; if(
     (atoi(shortcodewert) > 34) && ((atoi(shortcodewert) < 36) || (atoi(shortcodewert) > 37))) sc=1;
     if(atoi(shortcodewert) < 21) { fn=71; ms=53; }
     if(atoi(shortcodewert) == 5) { fn=73; ms=54; }
     if(atoi(shortcodewert) == 19) { fn=73; ms=54; }
     if(atoi(shortcodewert) > 20) fn=73; }

    /* 20 N/Y: N001,N002,N003,N005,N006,N007 */
    if((puffer[t] == 'N') && (puffer[sn] == 'Y') && (n==20)) { f=1; if(
     (atoi(shortcodewert) > 3) && ((atoi(shortcodewert) < 5) || (atoi(shortcodewert) > 7))) sc=1;
     if(atoi(shortcodewert) < 4) { fn=71; ms=53; }
     if(atoi(shortcodewert) > 4) fn=73; }

    /* 50 N/Y: N001 */
    if((puffer[t] == 'N') && (puffer[sn] == 'Y') && (n==50)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=70; ms=52; }

    /* 20 P/L: P011 */
    if((puffer[t] == 'P') && (puffer[sn] == 'L') && (n==20)) { f=1; if(atoi(shortcodewert) != 11) sc=1; fn=73; ms=53; }

    /* 100 P/M: P005 */
    if((puffer[t] == 'P') && (puffer[sn] == 'M') && (n==100)) { f=1; if(atoi(shortcodewert) != 5) sc=1; fn=71; ms=53; }

    /* 5 P/P: P006 */
    if((puffer[t] == 'P') && (puffer[sn] == 'P') && (n==5)) { f=1; if(atoi(shortcodewert) != 6) sc=1; }

    /* 10 P/P: these exists in 2002 and Europa series */
    if((puffer[t] == 'P') && (puffer[sn] == 'P') && (n==10))
     {
     if(isdigit(puffer[sn+1]))
      {
       /* 10 P/P: P001,P015 */
       f=1;
       if((atoi(shortcodewert) != 1) && (atoi(shortcodewert) != 15)) sc=1;
       fn=73;
      }
     else
      {
       /* 10 P/P Europa: P001,P002,P003,P004,P005,P006 */
       f=1;
       if(atoi(shortcodewert) > 6) sc=1;
       fn=73;
      }
     }

    /* 20 P/P: P009 */
    if((puffer[t] == 'P') && (puffer[sn] == 'P') && (n==20)) { f=1; if(atoi(shortcodewert) != 9) sc=1; fn=73; ms=53; }

    /* 50 P/P Europa: P001,P002,P003,P004,P005,P006,P007,P008,P009 */
    if((puffer[t] == 'P') && (puffer[sn] == 'P') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 9)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 100 P/U: P006,P007 */
    if((puffer[t] == 'P') && (puffer[sn] == 'U') && (n==100)) { f=1; if((atoi(shortcodewert) < 6) || (atoi(shortcodewert) > 7)) sc=1; fn=72; ms=53; }

    /* 50 P/V: P001 */
    if((puffer[t] == 'P') && (puffer[sn] == 'V') && (n==50)) { f=1; if(atoi(shortcodewert) != 1) sc=1; fn=72; ms=53; }

    /* 5 P/X: P001,P002,P003,P004,P006,P007,P008,P009,P010,P011,P012,P013,P014,P015,P016,P017,P018 */
    if((puffer[t] == 'P') && (puffer[sn] == 'X') && (n==5)) { f=1; if(
     (atoi(shortcodewert) > 4) && ((atoi(shortcodewert) < 6) || (atoi(shortcodewert) > 18))) sc=1; }

    /* 10 P/X: P001,P002,P003,P004,P005,P006,P007,P008,P009,P010,P011,P012,P013,P014,P015,P016,P017,
               P018,P019 */
    if((puffer[t] == 'P') && (puffer[sn] == 'X') && (n==10)) { f=1; if(atoi(shortcodewert) > 19) sc=1; fn=73; }

    /* 20 P/X: P001,P002,P003,P004,P005,P006,P007,P008,P009,P010,P011,P012,P013,P014,P015,P016,P017,
               P018,P019 */
    if((puffer[t] == 'P') && (puffer[sn] == 'X') && (n==20)) { f=1; if(atoi(shortcodewert) > 19) sc=1; fn=73; ms=53; }

    /* 50 P/X: P002,P003,P004,P005,P006,P007,P008,P009,P010,P011,P012,P013,P014,P015,P016,P017,P018,
               P019,P020,P021,P022,P023,P024,P025,P026,P027,P028,P029,P030,P031  */
    if((puffer[t] == 'P') && (puffer[sn] == 'X') && (n==50)) { f=1; if((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 31)) sc=1; fn=72; ms=53; }

    /* 100 P/X: P001,P002,P003,P004,P005,P007,P008,P009,P010 */
    if((puffer[t] == 'P') && (puffer[sn] == 'X') && (n==100)) { f=1; if(
     (atoi(shortcodewert) > 5) &&
     ((atoi(shortcodewert) < 7) || (atoi(shortcodewert) > 10))
     ) sc=1;
     if((atoi(shortcodewert) < 6)) fn=71;
     if((atoi(shortcodewert) == 7)) fn=72;
     if((atoi(shortcodewert) > 7)) fn=71;
     ms=53; }

    /* 5 P/Y: P005 */
    if((puffer[t] == 'P') && (puffer[sn] == 'Y') && (n==5)) { f=1; if(atoi(shortcodewert) != 5) sc=1; }

    /* 100 P/Y: P005 */
    if((puffer[t] == 'P') && (puffer[sn] == 'Y') && (n==100)) { f=1; if(atoi(shortcodewert) != 5) sc=1; fn=71; ms=53; }

    // 20 R/D: R026,R027,R028,R029,R030,R031
    if((puffer[t] == 'R') && (puffer[sn] == 'D') && (n==20)) { f=1; if(((atoi(shortcodewert) < 26) || (atoi(shortcodewert) > 31))) sc=1; fn=73; }

    // 50 R/D: R047,R049,R051
    if((puffer[t] == 'R') && (puffer[sn] == 'D') && (n==50)) { f=1; if(
     (atoi(shortcodewert) != 47) && (atoi(shortcodewert) != 49) && (atoi(shortcodewert) != 51)
     ) sc=1; fn=72; ms=53; }

    /* 20 R/E: R017,R020,R026,R027,R028,R029,R030,R031,R032 */
    if((puffer[t] == 'R') && (puffer[sn] == 'E') && (n==20)) { f=1; if(
     (atoi(shortcodewert) != 17) && (atoi(shortcodewert) != 20) && ((atoi(shortcodewert) < 26) || (atoi(shortcodewert) > 32))) sc=1; fn=73; }

    /* 50 R/E: R047,R048,R051,R052 */
    if((puffer[t] == 'R') && (puffer[sn] == 'E') && (n==50)) { f=1; if(
     (atoi(shortcodewert) != 47) && (atoi(shortcodewert) != 48) && (atoi(shortcodewert) != 51) && (atoi(shortcodewert) != 52)) sc=1; fn=72; ms=53; }

    /* 20 R/F: R026,R027,R029,R030,R031 */
    if((puffer[t] == 'R') && (puffer[sn] == 'F') && (n==20)) { f=1; if(
     (atoi(shortcodewert) != 26) && (atoi(shortcodewert) != 27) && ((atoi(shortcodewert) < 29) || (atoi(shortcodewert) > 31))) sc=1; fn=73; }

    /* 50 R/F: R049,R051 */
    if((puffer[t] == 'R') && (puffer[sn] == 'F') && (n==50)) { f=1; if((atoi(shortcodewert) != 49) && (atoi(shortcodewert) != 51)) sc=1; fn=72; ms=53; }

    /* 20 R/G: R026,R027,R030,R031 */
    if((puffer[t] == 'R') && (puffer[sn] == 'G') && (n==20)) { f=1; if(
     (atoi(shortcodewert) != 26) && (atoi(shortcodewert) != 27) && (atoi(shortcodewert) != 30) && (atoi(shortcodewert) != 31)) sc=1; fn=73; }

    /* 50 R/G: R049,R051 */
    if((puffer[t] == 'R') && (puffer[sn] == 'G') && (n==50)) { f=1; if((atoi(shortcodewert) != 49) && (atoi(shortcodewert) != 51)) sc=1; fn=72; ms=53; }

    /* 20 R/H: R026,R027,R028,R029,R031 */
    if((puffer[t] == 'R') && (puffer[sn] == 'H') && (n==20)) { f=1; if(
     ((atoi(shortcodewert) < 26) || (atoi(shortcodewert) > 29)) && (atoi(shortcodewert) != 31)) sc=1; fn=73; }

    /* 50 R/H: R047,R049,R051,R052 */
    if((puffer[t] == 'R') && (puffer[sn] == 'H') && (n==50)) { f=1; if(
     (atoi(shortcodewert) != 47) && (atoi(shortcodewert) != 49) && (atoi(shortcodewert) != 51) && (atoi(shortcodewert) != 52)) sc=1; fn=72; ms=53; }

    /* 20 R/L: R015,R020,R023,R024,R025,R026,R027,R029,R030,R031 */
    if((puffer[t] == 'R') && (puffer[sn] == 'L') && (n==20)) { f=1; if((atoi(shortcodewert) != 15) && (atoi(shortcodewert) != 20) &&
     ((atoi(shortcodewert) < 23) || (atoi(shortcodewert) > 27)) && ((atoi(shortcodewert) < 29) || (atoi(shortcodewert) > 31))) sc=1; fn=73; }

    /* 50 R/L: R047,R048,R049,R051 */
    if((puffer[t] == 'R') && (puffer[sn] == 'L') && (n==50)) { f=1; if(
     ((atoi(shortcodewert) < 47) || (atoi(shortcodewert) > 49)) && (atoi(shortcodewert) != 51)) sc=1; fn=72; ms=53; }

    // 5 R/P: R003
    if((puffer[t] == 'R') && (puffer[sn] == 'P') && (n==5)) { f=1; if(atoi(shortcodewert) != 3) sc=1; }

    /* 20 R/P: R015,R016,R017,R018,R019,R020,R021,R023,R024,R029,R030,R031,R032 */
    if((puffer[t] == 'R') && (puffer[sn] == 'P') && (n==20)) { f=1; if(
     ((atoi(shortcodewert) < 15) || (atoi(shortcodewert) > 21)) && ((atoi(shortcodewert) < 23) || (atoi(shortcodewert) > 24)) &&
     ((atoi(shortcodewert) < 29) || (atoi(shortcodewert) > 32))) sc=1; fn=73; }

    // 50 R/P: R044,R045,R046,R047,R048,R049
    if((puffer[t] == 'R') && (puffer[sn] == 'P') && (n==50)) { f=1; if(((atoi(shortcodewert) < 44) || (atoi(shortcodewert) > 49))) sc=1; fn=72; ms=53; }

    // 10 R/R Europa: R001,R002,R003,R004,R005,R006
    if((puffer[t] == 'R') && (puffer[sn] == 'R') && (n==10)) { f=1; if(
      (atoi(shortcodewert) > 6)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 20 R/R Europa: R001,R002,R003,R004,R005,R006,R007,R008,R010,R012,R013,R014,R015,R016,R018,
                      R020,R021,R022,R026,R027,R028,R029 */
    if((puffer[t] == 'R') && (puffer[sn] == 'R') && (n==20)) { f=1; if(
      (atoi(shortcodewert) > 8) &&
      (atoi(shortcodewert) != 10) &&
      ((atoi(shortcodewert) < 12) || (atoi(shortcodewert) > 16)) &&
      (atoi(shortcodewert) != 18) &&
      ((atoi(shortcodewert) < 20) || (atoi(shortcodewert) > 22)) &&
      ((atoi(shortcodewert) < 26) || (atoi(shortcodewert) > 29))
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 50 R/R Europa: R001,R002,R003,R004,R005,R008,R010,R011,R012,R013,R014,R015,R016,R021,R022,
                      R023,R024,R026,R027,R029,R030,R031,R032,R034,R035,R036,R037,R038,R039,R040,
                      R041 */
    if((puffer[t] == 'R') && (puffer[sn] == 'R') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 5) &&
      (atoi(shortcodewert) != 8) &&
      ((atoi(shortcodewert) < 10) || (atoi(shortcodewert) > 16)) &&
      ((atoi(shortcodewert) < 21) || (atoi(shortcodewert) > 24)) &&
      ((atoi(shortcodewert) < 26) || (atoi(shortcodewert) > 27)) &&
      ((atoi(shortcodewert) < 29) || (atoi(shortcodewert) > 32)) &&
      ((atoi(shortcodewert) < 34) || (atoi(shortcodewert) > 41))
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 100 R/R Europa: R001,R002,R003,R004,R005,R006,R007,R008,R009,R011 */
    if((puffer[t] == 'R') && (puffer[sn] == 'R') && (n==100)) { f=1; if(
      (atoi(shortcodewert) > 9) &&
      (atoi(shortcodewert) != 11)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 R/X: R001,R002,R004,R005,R006 */
    if((puffer[t] == 'R') && (puffer[sn] == 'X') && (n==5)) { f=1; if((atoi(shortcodewert) > 2) &&
     ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 6))) sc=1; }

    /* 10 R/X: R001,R002,R003,R004,R005,R006,R007,R008,R009,R010,R011,R012,R013,R015,R016,R017,R018,
               R019,R020,R021,R022,R023,R024,R025,R026 */
    if((puffer[t] == 'R') && (puffer[sn] == 'X') && (n==10)) { f=1; if(
     (atoi(shortcodewert) > 13) && ((atoi(shortcodewert) < 15) || (atoi(shortcodewert) > 26))) sc=1; fn=73; }

    /* 20 R/X: R001,R002,R003,R004,R005,R006,R007,R008 */
    if((puffer[t] == 'R') && (puffer[sn] == 'X') && (n==20)) { f=1; if(atoi(shortcodewert) > 8) sc=1; fn=73; }

    /* 50 R/X: R001,R002,R004,R005,R006,R008,R011,R012,R013,R015,R016,R017,R018,R019,R020,R021,R022,
               R023,R024,R025,R026,R027,R028,R029,R030,R031,R032,R033,R034,R035,R036,R037,R038,R039,
               R041,R055,R056,R057,R058,R059 */
    if((puffer[t] == 'R') && (puffer[sn] == 'X') && (n==50)) { f=1; if(
     (atoi(shortcodewert) > 2) && ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 6)) &&
     (atoi(shortcodewert) != 8) && ((atoi(shortcodewert) < 11) || (atoi(shortcodewert) > 39)) &&
     (atoi(shortcodewert) != 41) && ((atoi(shortcodewert) < 55) || (atoi(shortcodewert) > 59))) sc=1; fn=72; ms=53; }

    /* 100 R/X: R001,R002,R003,R006,R007,R008,R009,R010,R011 */
    if((puffer[t] == 'R') && (puffer[sn] == 'X') && (n==100)) { f=1; if(
     (atoi(shortcodewert) > 3) && ((atoi(shortcodewert) < 6) || (atoi(shortcodewert) > 11))
     ) sc=1; fn=72; ms=53; }

    /* 200 R/X: R001,R002,R005,R006,R008,R009 */
    if((puffer[t] == 'R') && (puffer[sn] == 'X') && (n==200)) { f=1; if((atoi(shortcodewert) > 2) &&
     ((atoi(shortcodewert) < 5) || (atoi(shortcodewert) > 6)) && ((atoi(shortcodewert) < 8) || (atoi(shortcodewert) > 9))) sc=1;
     if((atoi(shortcodewert) < 8)) { fn=71; ms=52; }
      else { fn=72; ms=53; }
     }

    /* 500 R/X: R001,R002,R003,R004,R007,R008,R009,R010,R011,R012,R013,R014,R015,R017,R018,R019,R020 */
    if((puffer[t] == 'R') && (puffer[sn] == 'X') && (n==500)) { f=1; if((atoi(shortcodewert) > 4) &&
     ((atoi(shortcodewert) < 7) || (atoi(shortcodewert) > 15)) && ((atoi(shortcodewert) < 17) || (atoi(shortcodewert) > 20))) sc=1; fn=71; ms=52; }

    /* 200 R/Y: R003 */
    if((puffer[t] == 'R') && (puffer[sn] == 'Y') && (n==200)) { f=1; if(atoi(shortcodewert) != 3) sc=1; fn=71; ms=52; }

    /* 500 R/Y: R005 */
    if((puffer[t] == 'R') && (puffer[sn] == 'Y') && (n==500)) { f=1; if(atoi(shortcodewert) != 5) sc=1; fn=71; ms=52; }

    /* 5 S/S Europa: S001,S002,S003,S006 */
    if((puffer[t] == 'S') && (puffer[sn] == 'S') && (n==5)) { f=1; if((atoi(shortcodewert) > 3) && (atoi(shortcodewert) != 6)) sc=1;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 10 S/S Europa: S002,S003,S004,S005 */
    if((puffer[t] == 'S') && (puffer[sn] == 'S') && (n==10)) { f=1; if(
      ((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 5))
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 20 S/S Europa: S001,S003,S004,S005,S006,S007,S008,S009,S010,S011,S012,S013,S014,S015,S016,S017,
                      S018,S019,S020,S021,S022,S023,S024,S025,S026,S027 */
    if((puffer[t] == 'S') && (puffer[sn] == 'S') && (n==20)) { f=1; if(
      (atoi(shortcodewert) != 1) &&
      ((atoi(shortcodewert) < 3) || (atoi(shortcodewert) > 27))
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 50 S/S Europa: S002,S003,S004,S005,S006,S007,S008,S009,S010,S011,S012,S014,S015,S016,S017,S018,
                      S019,S021,S022,S024,S025,S026,S027,S028,S029,S030,S031,S032,S033,S034,S035,S036,
                      S037,S038,S039,S040,S041,S042,S046,S048,S049,S050,S052,S053 */
    if((puffer[t] == 'S') && (puffer[sn] == 'S') && (n==50)) { f=1; if(
      ((atoi(shortcodewert) <  2) || (atoi(shortcodewert) > 12)) &&
      ((atoi(shortcodewert) < 14) || (atoi(shortcodewert) > 19)) &&
      ((atoi(shortcodewert) < 21) || (atoi(shortcodewert) > 22)) &&
      ((atoi(shortcodewert) < 24) || (atoi(shortcodewert) > 42)) &&
      (atoi(shortcodewert) != 46) &&
      ((atoi(shortcodewert) < 48) || (atoi(shortcodewert) > 50)) &&
      ((atoi(shortcodewert) < 52) || (atoi(shortcodewert) > 53))
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 100 S/S Europa: S002,S003,S004,S005,S007,S008,S009
    if((puffer[t] == 'S') && (puffer[sn] == 'S') && (n==100)) { f=1; if(
      ((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 5)) &&
      (atoi(shortcodewert) != 7) &&
      (atoi(shortcodewert) != 8) &&
      (atoi(shortcodewert) != 9)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 200 S/S Europa: S002,S004,S005,S006,S008 */
    if((puffer[t] == 'S') && (puffer[sn] == 'S') && (n==200)) { f=1; if(
      (atoi(shortcodewert) != 2) &&
      ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) > 6)) &&
      (atoi(shortcodewert) != 8)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 T/T Europa: T001,T002,T003,T004,T005 */
    if((puffer[t] == 'T') && (puffer[sn] == 'T') && (n==5)) { f=1; if(
     (atoi(shortcodewert) > 5)
     ) sc=1;
     if(isdigit(puffer[sn+1])) en=1;
     }

    /* 10 T/T Europa: T001,T002,T003,T004 */
    if((puffer[t] == 'T') && (puffer[sn] == 'T') && (n==10)) { f=1; if(
     (atoi(shortcodewert) > 4)
     ) sc=1; fn=73;
     if(isdigit(puffer[sn+1])) en=1;
     }

    // 20 T/T Europa: T001,T002,T003,T004,T005,T006,T008,T010
    if((puffer[t] == 'T') && (puffer[sn] == 'T') && (n==20)) { f=1; if(
     (atoi(shortcodewert) > 6) &&
     (atoi(shortcodewert) != 8) &&
     (atoi(shortcodewert) != 10)
     ) sc=1; fn=73;
     if(isdigit(puffer[sn+1])) en=1;
     }

    /* 200 T/U: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'U') && (n==200)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 500 T/U: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'U') && (n==500)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 200 T/V: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'V') && (n==200)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 500 T/V: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'V') && (n==500)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 5 T/Z: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'Z') && (n==5)) { f=1; if(atoi(shortcodewert) > 1) sc=1; }

    /* 10 T/Z: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'Z') && (n==10)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=73; }

    /* 20 T/Z: T001,T002 */
    if((puffer[t] == 'T') && (puffer[sn] == 'Z') && (n==20)) { f=1; if(atoi(shortcodewert) > 2) sc=1; fn=73; }

    /* 50 T/Z: T001,T002,T003,T004,T005,T006,T007,T008,T009,T010,T011,T013,T014,T015,T016,T017,T018,
               T019,T020,T021,T026,T028,T029,T031,T033,T034,T035,T036,T037,T038,T039 */
    if((puffer[t] == 'T') && (puffer[sn] == 'Z') && (n==50)) { f=1; if(
     (atoi(shortcodewert) > 11) && ((atoi(shortcodewert) < 13) || (atoi(shortcodewert) > 21)) && (atoi(shortcodewert) != 26) &&
     ((atoi(shortcodewert) < 28) || (atoi(shortcodewert) > 29)) && ((atoi(shortcodewert) < 31) || (atoi(shortcodewert) > 39))) sc=1;
     if(atoi(shortcodewert) < 7) fn=71;
     if(atoi(shortcodewert) > 6) fn=72;
     ms=53; }

    /* 100 T/Z: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'Z') && (n==100)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 200 T/Z: T001,T002,T003 */
    if((puffer[t] == 'T') && (puffer[sn] == 'Z') && (n==200)) { f=1; if(atoi(shortcodewert) > 3) sc=1; fn=71; ms=53; }

    /* 500 T/Z: T001 */
    if((puffer[t] == 'T') && (puffer[sn] == 'Z') && (n==500)) { f=1; if(atoi(shortcodewert) > 1) sc=1; fn=71; ms=53; }

    /* 5 U/M: U001,U002,U003,U004,U005,U006,U007,U008 */
    if((puffer[t] == 'U') && (puffer[sn] == 'M') && (n==5)) { f=1; if(atoi(shortcodewert) > 8) sc=1; }

    /* 10 U/M: U001,U003,U004,U005,U006,U007,U008 */
    if((puffer[t] == 'U') && (puffer[sn] == 'M') && (n==10)) { f=1; if(
     (atoi(shortcodewert) != 1) && ((atoi(shortcodewert) < 3) || (atoi(shortcodewert) > 8))) sc=1; fn=73; }

    /* 20 U/M: U001,U002,U003,U004,U005,U006,U007,U008,U009,U010,U011,U012,U013,U014,U015,U016,U017,
               U018,U019,U020,U021,U022,U023,U024,U025 */
    if((puffer[t] == 'U') && (puffer[sn] == 'M') && (n==20)) { f=1; if(atoi(shortcodewert) > 25) sc=1; fn=73; ms=53; }

    /* 5 U/U Europa: U002,U003,U004,U005,U006,U007,U008,U009,U011,U012 */
    if((puffer[t] == 'U') && (puffer[sn] == 'U') && (n==5)) { f=1; if(
      ((atoi(shortcodewert) < 2) || (atoi(shortcodewert) > 9)) &&
      ((atoi(shortcodewert) < 11) || (atoi(shortcodewert) > 12))
      ) sc=1;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 10 U/U Europa: U001,U002,U003,U004,U005,U006,U007,U008,U009,U010,U011,U012,U013 */
    if((puffer[t] == 'U') && (puffer[sn] == 'U') && (n==10)) { f=1; if(
      (atoi(shortcodewert) > 13)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 20 U/U Europa: U001,U002,U003,U004,U005,U006,U007,U008,U009,U010,U011,U012,U013,U014,U015,U016,
                      U017,U018,U019,U020,U021,U022,U023,U024,U025,U026,U027,U028,U029,U030,U031,U032
                      U033,U034,U035,U037,U038,U039,U040,U041,U042,U043,U044,U045,U046,U047,U051 */
    if((puffer[t] == 'U') && (puffer[sn] == 'U') && (n==20)) { f=1; if(
      (atoi(shortcodewert) > 35) &&
      ((atoi(shortcodewert) < 37) || (atoi(shortcodewert) > 47)) &&
      (atoi(shortcodewert) != 51)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 50 U/U Europa: U001,U002,U003,U004,U005,U006,U007,U008,U009,U010,U011,U012,U013,U014,U015,U016,
                      U017,U018,U019,U020,U021,U022,U023,U024,U025,U026,U027,U028,U029,U030,U031,U032,
                      U033,U034,U035,U036,U037,U038,U039,U040,U041,U042,U043,U044,U045,U048,U049,U050 */
    if((puffer[t] == 'U') && (puffer[sn] == 'U') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 45) &&
      ((atoi(shortcodewert) < 48) || (atoi(shortcodewert) > 50))
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     } 

    // 100 U/U Europa: U001,U002,U003,U004,U005
    if((puffer[t] == 'U') && (puffer[sn] == 'U') && (n==100)) { f=1; if(
      (atoi(shortcodewert) > 5)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 200 U/U Europa: U001,U002,U003,U004,U005 */
    if((puffer[t] == 'U') && (puffer[sn] == 'U') && (n==200)) { f=1; if(
      (atoi(shortcodewert) > 5)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 V/V Europa: V001,V002,V003,V004,V005,V006,V007,V008,V009,V010,V011,V012,V013,V014,V015,
                     V016  */
    if((puffer[t] == 'V') && (puffer[sn] == 'V') && (n==5)) { f=1; if(
      (atoi(shortcodewert) > 16)
      ) sc=1;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 10 V/V Europa: V001,V002,V003,V004,V005,V006,V007,V008,V009,V010,V011,V012
    if((puffer[t] == 'V') && (puffer[sn] == 'V') && (n==10)) { f=1; if(
      (atoi(shortcodewert) > 12)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 20 V/V Europa: V001,V002,V003,V004,V005,V006
    if((puffer[t] == 'V') && (puffer[sn] == 'V') && (n==20)) { f=1; if(
      (atoi(shortcodewert) > 6)
      ) sc=1; fn=73; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 50 V/V Europa: V001,V002,V003,V004,V005,V006,V007,V008,V009,V010,V011,V012,V013,V014,V015,
                      V016,V017,V018,V019,V020,V021,V022,V023,V024,V025,V026,V027,V028,V029,V030,
                      V031,V032,V033,V034 */
    if((puffer[t] == 'V') && (puffer[sn] == 'V') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 34)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 100 V/V Europa: V001,V002,V003,V004 */
    if((puffer[t] == 'V') && (puffer[sn] == 'V') && (n==100)) { f=1; if(
      (atoi(shortcodewert) > 4)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 W/W Europa: W001,W002 */
    if((puffer[t] == 'W') && (puffer[sn] == 'W') && (n==5)) { f=1; if(atoi(shortcodewert) > 2) sc=1;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 10 W/W Europa: W001,W002,W003,W004,W005,W006,W007,W008,W009,W010,W011
    if((puffer[t] == 'W') && (puffer[sn] == 'W') && (n==10)) { f=1; if(atoi(shortcodewert) > 11) sc=1;
      fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 20 W/W Europa: W001,W002 */
    if((puffer[t] == 'W') && (puffer[sn] == 'W') && (n==20)) { f=1; if(atoi(shortcodewert) > 2) sc=1;
      fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 50 W/W Europa: W001,W002,W003,W004,W005,W006,W007,W008,W009,W010,W011,W012,W013,W014,W015,
                      W016 */
    if((puffer[t] == 'W') && (puffer[sn] == 'W') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 16)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 100 W/W Europa: W001,W002,W003,W004
    if((puffer[t] == 'W') && (puffer[sn] == 'W') && (n==100)) { f=1; if(
      (atoi(shortcodewert) > 5)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 10 X/X Europa: X001,X002,X003 */
    if((puffer[t] == 'X') && (puffer[sn] == 'X') && (n==10)) { f=1; if(
      (atoi(shortcodewert) > 3)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 20 X/X Europa: X001,X002,X003 */
    if((puffer[t] == 'X') && (puffer[sn] == 'X') && (n==20)) { f=1; if(atoi(shortcodewert) > 3) sc=1;
      fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 Y/Y Europa: Y001,Y002,Y003,Y004,Y005,Y006,Y007 */
    if((puffer[t] == 'Y') && (puffer[sn] == 'Y') && (n==5)) { f=1; if(
      (atoi(shortcodewert) > 7)
      ) sc=1;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 10 Y/Y Europa: Y001,Y002,Y003,Y004,Y005,Y006,Y007,Y008,Y009,Y010,Y011,Y012,Y013 */
    if((puffer[t] == 'Y') && (puffer[sn] == 'Y') && (n==10)) { f=1; if(
      (atoi(shortcodewert) > 13)
      ) sc=1; fn=73;
      if(isdigit(puffer[sn+1])) en=1;
     }

    // 50 Y/Y Europa: Y001,Y002,Y003,Y004
    if((puffer[t] == 'Y') && (puffer[sn] == 'Y') && (n==50)) { f=1; if(
      (atoi(shortcodewert) > 4)
      ) sc=1; fn=72; ms=53;
      if(isdigit(puffer[sn+1])) en=1;
     }

    /* 5 Z/Z Europa: Z003,Z004,Z005,Z006,Z009,Z020, Z021
       bhoeyb found a Z002/Z note with Trichet signature, but it looks like this was only a test note
       and all of them should be destroyed. According to his Facebook posting, NBB said that this is
       not an offical euro note. */
    if((puffer[t] == 'Z') && (puffer[sn] == 'Z') && (n==5)) { f=1; if(
      ((atoi(shortcodewert) < 3) || (atoi(shortcodewert) > 6)) &&
      (atoi(shortcodewert) != 9) &&
      (atoi(shortcodewert) != 20) &&
      (atoi(shortcodewert) != 21)
      ) sc=1;
      if(isdigit(puffer[sn+1])) en=1;
      if(atoi(shortcodewert) == 2) {
        if(progtype==1)
         {
          printf("You have entered a Belgium 5 euro series 2013 note with the shortcode Z002. This is a very rare note and only one known.\n");
          printf("There could be three reasons:\n");
          printf("1. You are bhoeyb.\n");
          printf("2. You found really another Z002/Z note. Please keep it and report it in the forum.\n");
          printf("3. Typing error. (in most cases it is some kind like a 5 Z020/ZD....)\n");
         } 
        else
         {
          printf("<FONT COLOR=red>You have entered a Belgium 5 euro series 2013 note with the shortcode Z002. This is a very rare note and only one known.</FONT><BR>");
          printf("There could be three reasons:<BR>");
          printf("1. You are bhoeyb.<BR>");
          printf("2. You found really another Z002/Z note. Please keep it and report it in the forum.<BR>");
          printf("3. Typing error. (in most cases it is some kind like a 5 Z020/ZD....)<BR>");
         }
       }
     }

    // 20 Z/Z Europa: Z001,Z002,Z020
    if((puffer[t] == 'Z') && (puffer[sn] == 'Z') && (n==20)) { f=1; if(
      (atoi(shortcodewert) > 2) &&
      (atoi(shortcodewert) != 20)
      ) sc=1;
      fn=73;
      if(atoi(shortcodewert) > 1 ) { fn=72; ms=53; }
      if(isdigit(puffer[sn+1])) en=1;
    }

    // 50 Z/Z Europa: Z001,Z002,Z003,Z004,Z005,Z007,Z020,Z021,Z022
    if((puffer[t] == 'Z') && (puffer[sn] == 'Z') && (n==50)) { f=1; if(
     (atoi(shortcodewert) > 5) &&
     (atoi(shortcodewert) != 7) &&
     ((atoi(shortcodewert) < 20) || (atoi(shortcodewert) > 22))
     ) sc=1; fn=72; ms=53;
     if(isdigit(puffer[sn+1])) en=1;
     }
   }
